import cf

import os

def test(chunk_sizes=(17, 34, 60, 300, 100000)):

    #import create_field
    
    #f = create_field.test()
    filename = os.path.join(os.path.dirname(os.path.abspath(__file__)),
                            "test_file.nc")
    original_chunksize = cf.CHUNKSIZE()

    cf.CHUNKSIZE(10000000)
    f = cf.read(filename, squeeze=True)[0]
            
    for chunksize in chunk_sizes[::-1]:

        f.aux('aux0').id = 'atmosphere_hybrid_height_coordinate_ak'
        f.aux('aux1').id = 'atmosphere_hybrid_height_coordinate_bk'

        g0 = cf.FieldList([f.subspace[i] for i in range(f.shape[0])])
        g  = cf.FieldList([f.subspace[i] for i in range(f.shape[0])])
        
        assert g.equals(g0, traceback=True), "g does not equal itself"
        
        h = cf.aggregate(g, messages=1)
        
        assert h[0].shape == (10, 9), 'h[0].shape is '+repr(h[0].shape)
        
        assert g.equals(g0, traceback=True), "g does not equal itself after aggregation"
        
        i = cf.aggregate(g, messages=1)
        
        assert i.equals(h, traceback=True), "The second aggregation didn't equal the first"
        
        assert g.equals(g0, traceback=True), "g does not equal itself after the second aggregation"
        
        i = cf.aggregate(g, messages=1, axes='grid_latitude')
        
        assert i.equals(h, traceback=True), "The third aggregation didn't equal the first"
        
        assert g.equals(g0, traceback=True), "g does not equal itself after the third aggregation"
        
        assert i[0].shape == (10,9), 'i[0].shape is '+repr(i[0].shape)    
        
        i = cf.aggregate(g, messages=1, axes='grid_latitude', donotchecknonaggregatingaxes=1)
        
        assert i.equals(h, traceback=True), "The fourth aggregation didn't equal the first"
        
        assert g.equals(g0, traceback=True), "g does not equal itself after the fourth aggregation"
        
        assert i[0].shape == (10,9), 'i[0].shape is '+repr(i[0].shape)    
    #--- End: for

    print
    print '---------------------------------------------------------------------------'
    print 'All aggregation tests passed for cf version', cf.__version__
    print 'Running from', os.path.abspath(cf.__file__)
    print '---------------------------------------------------------------------------'
#--- End: def

if __name__ == "__main__":
    test()
